# List waterfall runs (/docs/api/waterfalls/waterfall_runs)

Recent runs of one waterfall: outcome, cost, time, attempts and fields filled.

`GET /v1/waterfalls/{id}/runs`

```json
{
  "operationId": "waterfall_runs",
  "summary": "List waterfall runs",
  "description": "Recent runs of one waterfall: outcome, cost, time, attempts and fields filled.",
  "tags": [
    "waterfalls"
  ],
  "security": [
    {
      "bearer": []
    }
  ],
  "parameters": [
    {
      "schema": {
        "type": "string",
        "pattern": "^wf_[a-z0-9]{8,40}$"
      },
      "required": true,
      "name": "id",
      "in": "path"
    },
    {
      "schema": {
        "type": "integer",
        "minimum": 1,
        "maximum": 100,
        "default": 20
      },
      "required": false,
      "name": "limit",
      "in": "query"
    },
    {
      "schema": {
        "type": "string",
        "format": "date-time",
        "description": "Return runs created before this time"
      },
      "required": false,
      "description": "Return runs created before this time",
      "name": "before",
      "in": "query"
    }
  ],
  "responses": {
    "200": {
      "description": "OK",
      "content": {
        "application/json": {
          "schema": {
            "type": "object",
            "properties": {
              "items": {
                "type": "array",
                "items": {
                  "type": "object",
                  "properties": {
                    "object": {
                      "type": "string",
                      "enum": [
                        "waterfall_run"
                      ]
                    },
                    "id": {
                      "type": "string",
                      "pattern": "^wfr_[a-z0-9]{8,64}$"
                    },
                    "waterfall_id": {
                      "type": "string"
                    },
                    "version": {
                      "type": "string"
                    },
                    "mode": {
                      "type": "string",
                      "enum": [
                        "sync",
                        "wait",
                        "async",
                        "batch",
                        "list",
                        "scheduled",
                        "test"
                      ]
                    },
                    "status": {
                      "type": "string",
                      "enum": [
                        "queued",
                        "running",
                        "completed",
                        "failed",
                        "cancelled"
                      ]
                    },
                    "outcome": {
                      "type": [
                        "string",
                        "null"
                      ],
                      "enum": [
                        "hit",
                        "partial",
                        "miss",
                        "failed",
                        null
                      ]
                    },
                    "stop_reason": {
                      "type": [
                        "string",
                        "null"
                      ],
                      "enum": [
                        "first_hit",
                        "first_verified",
                        "until_fields_filled",
                        "all_then_merge",
                        "condition",
                        "exhausted",
                        "budget_exceeded",
                        "deadline_exceeded",
                        "cancelled",
                        "account_error",
                        null
                      ]
                    },
                    "fields_filled": {
                      "type": "array",
                      "items": {
                        "type": "string"
                      }
                    },
                    "cost_micro": {
                      "type": "integer",
                      "minimum": 0
                    },
                    "latency_ms": {
                      "type": "integer",
                      "minimum": 0
                    },
                    "batch_id": {
                      "type": [
                        "string",
                        "null"
                      ]
                    },
                    "created_at": {
                      "type": "string",
                      "format": "date-time"
                    },
                    "completed_at": {
                      "type": [
                        "string",
                        "null"
                      ],
                      "format": "date-time"
                    },
                    "attempts": {
                      "type": "integer",
                      "minimum": 0
                    }
                  },
                  "required": [
                    "object",
                    "id",
                    "waterfall_id",
                    "version",
                    "mode",
                    "status",
                    "outcome",
                    "stop_reason",
                    "fields_filled",
                    "cost_micro",
                    "latency_ms",
                    "batch_id",
                    "created_at",
                    "completed_at",
                    "attempts"
                  ]
                }
              },
              "next_cursor": {
                "type": [
                  "string",
                  "null"
                ]
              }
            },
            "required": [
              "items",
              "next_cursor"
            ]
          }
        }
      }
    },
    "default": {
      "description": "Error",
      "content": {
        "application/json": {
          "schema": {
            "type": "object",
            "properties": {
              "error": {
                "type": "object",
                "properties": {
                  "code": {
                    "type": "string",
                    "enum": [
                      "invalid_request",
                      "unauthorized",
                      "insufficient_balance",
                      "max_cost_exceeded",
                      "scope_denied",
                      "budget_blocked",
                      "not_found",
                      "idempotency_mismatch",
                      "invalid_meta",
                      "rate_limited",
                      "upstream_error",
                      "response_buffer_limit",
                      "provider_capacity_unavailable",
                      "grid_saturated",
                      "upstream_timeout",
                      "conflict",
                      "internal_error",
                      "account_frozen",
                      "strict_filters",
                      "plan_limit_reached",
                      "validation_failed",
                      "deadline_exceeded",
                      "cancelled"
                    ]
                  },
                  "message": {
                    "type": "string"
                  },
                  "request_id": {
                    "type": "string"
                  },
                  "call_id": {
                    "type": "string"
                  },
                  "retry_after_ms": {
                    "type": "integer",
                    "minimum": 0
                  },
                  "details": {
                    "type": "object",
                    "additionalProperties": {}
                  }
                },
                "required": [
                  "code",
                  "message"
                ]
              }
            },
            "required": [
              "error"
            ]
          }
        }
      }
    }
  }
}
```
